/*
	Copyright (c) 2004-2009, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource["dojox.charting.Theme"]){
dojo._hasResource["dojox.charting.Theme"]=true;
dojo.provide("dojox.charting.Theme");
dojo.require("dojox.color");
dojo.require("dojox.color.Palette");
dojo.require("dojox.lang.utils");
dojo.declare("dojox.charting.Theme",null,{shapeSpaces:{shape:1,shapeX:1,shapeY:1},constructor:function(_1){
_1=_1||{};
var _2=dojox.charting.Theme.defaultTheme;
dojo.forEach(["chart","plotarea","axis","series","marker"],function(_3){
this[_3]=dojo.delegate(_2[_3],_1[_3]);
},this);
if(_1.seriesThemes&&_1.seriesThemes.length){
this.seriesThemes=_1.seriesThemes.slice(0);
this.colors=null;
}else{
this.seriesThemes=null;
this.colors=(_1.colors||dojox.charting.Theme.defaultColors).slice(0);
}
this.markerThemes=null;
if(_1.markerThemes&&_1.markerThemes.length){
this.markerThemes=_1.markerThemes.slice(0);
}
this.markers=dojo.delegate(dojox.charting.Theme.defaultMarkers,_1.markers);
this.noGradConv=_1.noGradConv;
this.noRadialConv=_1.noRadialConv;
this._current=0;
this._buildMarkerArray();
},clone:function(){
return new dojox.charting.Theme({chart:this.chart,plotarea:this.plotarea,axis:this.axis,series:this.series,marker:this.marker,colors:this.colors,markers:this.markers,seriesThemes:this.seriesThemes,markerThemes:this.markerThemes,noGradConv:this.noGradConv,noRadialConv:this.noRadialConv});
},clear:function(){
this._current=0;
},next:function(_4,_5,_6){
var _7=dojox.lang.utils.merge,_8,_9;
if(this.colors){
_8=dojo.delegate(this.series);
_9=dojo.delegate(this.marker);
var _a=new dojo.Color(this.colors[this._current%this.colors.length]),_b;
if(_8.stroke&&_8.stroke.color){
_8.stroke=dojo.delegate(_8.stroke);
_b=new dojo.Color(_8.stroke.color);
_8.stroke.color=new dojo.Color(_a);
_8.stroke.color.a=_b.a;
}else{
_8.stroke={color:_a};
}
if(_9.stroke&&_9.stroke.color){
_9.stroke=dojo.delegate(_9.stroke);
_b=new dojo.Color(_9.stroke.color);
_9.stroke.color=new dojo.Color(_a);
_9.stroke.color.a=_b.a;
}else{
_9.stroke={color:_a};
}
if(!_8.fill||_8.fill.type){
_8.fill=_a;
}else{
_b=new dojo.Color(_8.fill);
_8.fill=new dojo.Color(_a);
_8.fill.a=_b.a;
}
if(!_9.fill||_9.fill.type){
_9.fill=_a;
}else{
_b=new dojo.Color(_9.fill);
_9.fill=new dojo.Color(_a);
_9.fill.a=_b.a;
}
}else{
_8=this.seriesThemes?_7(this.series,this.seriesThemes[this._current%this.seriesThemes.length]):this.series;
_9=this.markerThemes?_7(this.marker,this.markerThemes[this._current%this.markerThemes.length]):_8;
}
var _c=this._markers[this._current++%this._markers.length];
var _d={series:_8,marker:_9,symbol:_c};
if(_5){
if(dojo.isArray(_5)){
for(var i=0;i<_5.length;++i){
_d=this.addMixin(_d,_4,_5[i]);
}
}else{
_d=this.addMixin(_d,_4,_5);
}
}
if(_6){
_d=this.post(_d,_4);
}
return _d;
},skip:function(){
++this._current;
},addMixin:function(_e,_f,_10,_11){
var t={};
if("color" in _10){
if(_f=="line"){
dojo.setObject("series.stroke.color",_10.color,t);
dojo.setObject("marker.stroke.color",_10.color,t);
}else{
dojo.setObject("series.fill",_10.color,t);
}
}
dojo.forEach(["stroke","outline","shadow","fill","font","fontColor"],function(_12){
var _13="marker"+_12.charAt(0).toUpperCase()+_12.substr(1),b=_13 in _10;
if(_12 in _10){
dojo.setObject("series."+_12,_10[_12],t);
if(!b){
dojo.setObject("marker."+_12,_10[_12],t);
}
}
if(b){
dojo.setObject("marker."+_12,_10[_13],t);
}
});
if("marker" in _10){
t.symbol=_10.marker;
}
var _14=dojox.lang.utils.merge(_e,t);
if(_11){
_14=this.post(_14,_f);
}
return _14;
},post:function(_15,_16){
var _17=_15.series.fill,t;
if(!this.noGradConv&&this.shapeSpaces[_17.space]&&_17.type=="linear"){
if(_16=="bar"){
t={x1:_17.y1,y1:_17.x1,x2:_17.y2,y2:_17.x2};
}else{
if(!this.noRadialConv&&_17.space=="shape"&&(_16=="slice"||_16=="circle")){
t={type:"radial",cx:0,cy:0,r:100};
}
}
if(t){
return dojox.lang.utils.merge(_15,{series:{fill:t}});
}
}
return _15;
},getTick:function(_18,_19){
var _1a=this.axis.tick,_1b=_18+"Tick";
merge=dojox.lang.utils.merge;
if(_1a){
if(this.axis[_1b]){
_1a=merge(_1a,this.axis[_1b]);
}
}else{
_1a=this.axis[_1b];
}
if(_19){
if(_1a){
if(_19[_1b]){
_1a=merge(_1a,_19[_1b]);
}
}else{
_1a=_19[_1b];
}
}
return _1a;
},addMarker:function(_1c,_1d){
this.markers[_1c]=_1d;
this._buildMarkerArray();
},setMarkers:function(obj){
this.markers=obj;
this._buildMarkerArray();
},_buildMarkerArray:function(){
this._markers=[];
for(var p in this.markers){
this._markers.push(this.markers[p]);
}
}});
dojo.mixin(dojox.charting.Theme,{defaultMarkers:{CIRCLE:"m-3,0 c0,-4 6,-4 6,0 m-6,0 c0,4 6,4 6,0",SQUARE:"m-3,-3 l0,6 6,0 0,-6 z",DIAMOND:"m0,-3 l3,3 -3,3 -3,-3 z",CROSS:"m0,-3 l0,6 m-3,-3 l6,0",X:"m-3,-3 l6,6 m0,-6 l-6,6",TRIANGLE:"m-3,3 l3,-6 3,6 z",TRIANGLE_INVERTED:"m-3,-3 l3,6 3,-6 z"},defaultColors:["#54544c","#858e94","#6e767a","#948585","#474747"],defaultTheme:{chart:{stroke:null,fill:"white"},plotarea:{stroke:null,fill:"white"},axis:{stroke:{color:"#333",width:1},tick:{color:"#666",position:"center",font:"normal normal normal 7pt Tahoma",fontColor:"#333"},majorTick:{width:1,length:6},minorTick:{width:0.8,length:3},microTick:{width:0.5,length:1}},series:{stroke:{width:1.5,color:"#333"},outline:{width:0.1,color:"#ccc"},shadow:null,fill:"#ccc",font:"normal normal normal 8pt Tahoma",fontColor:"#000"},marker:{stroke:{width:1.5,color:"#333"},outline:{width:0.1,color:"#ccc"},shadow:null,fill:"#ccc",font:"normal normal normal 8pt Tahoma",fontColor:"#000"}},defineColors:function(_1e){
_1e=_1e||{};
var c=[],n=_1e.num||5;
if(_1e.colors){
var l=_1e.colors.length;
for(var i=0;i<n;i++){
c.push(_1e.colors[i%l]);
}
return c;
}
if(_1e.hue){
var s=_1e.saturation||100;
var st=_1e.low||30;
var end=_1e.high||90;
var l=(end+st)/2;
return dojox.color.Palette.generate(dojox.color.fromHsv(_1e.hue,s,l),"monochromatic").colors;
}
if(_1e.generator){
return dojox.color.Palette.generate(_1e.base,_1e.generator).colors;
}
return c;
}});
}
